#! /bin/sh
#
# Copyright (c) 1989 Jan-Simon Pendry
# Copyright (c) 1989 Imperial College of Science, Technology & Medicine
# Copyright (c) 1989 The Regents of the University of California.
# All rights reserved.
#
# This code is derived from software contributed to Berkeley by
# Jan-Simon Pendry at Imperial College, London.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
#      This product includes software developed by the University of
#      California, Berkeley and its contributors.
# 4. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
#	%W% (Berkeley) %G%
#
# $Id: arch,v 5.2.2.2 1992/05/31 16:45:35 jsp Exp $
#
# Figure out machine architecture
#

PATH=/bin:/usr/bin:/usr/ucb:/etc:/usr/local/bin:${PATH} export PATH

#
# First try to find a standard command
#
a=arch		# Sun compat
m=machine	# BSD compat
u=uname		# Sys5 compat

if [ -f /etc/$a -o -f /bin/$a -o -f /usr/bin/$a -o -f /usr/local/bin/$a ]
then
	exec $a
elif [ -f /etc/$m -o -f /bin/$m -o -f /usr/bin/$m -o -f /usr/ucb/$m -o -f /usr/local/bin/$m ]
then
	exec $m
elif [ -f /etc/$u -o -f /bin/$u -o -f /usr/bin/$u -o -f /usr/local/bin/$u ]
then
	ARCH="`uname`"
	case "$ARCH" in
		"HP-UX") echo hp9000; exit 0;;
		AIX*) MACH="`uname -m`"
			case "$MACH" in
			00*) echo ibm6000; exit 0;;
			10*) echo ibm032; exit 0;;
			20*) echo ibm032; exit 0;;
			esac
			;;
		A/UX) echo macII ; exit 0 ;;
		dgux) MACH="`uname -m`"
			case "$MACH" in
			AViiON) echo aviion; exit 0;;
			esac
			;;
		*) MACH="`uname -m`"
			case "$MACH" in
			IP6) echo mips; exit 0;;
			IP7) echo mips; exit 0;;
			IP20) echo mips; exit 0;;
			*) ;;
			esac
			;;
	esac
fi

#
# Take a pot-shot at your machine architecture
#
echo "#	... No ARCH= option specified; dynamically determining architecture" >&2

case "`exec 2>/dev/null; head -2 /etc/motd`" in
*"HP-UX"*)		ARCH=hp9000;;
*"Iris"*)		ARCH=iris4d;;
*"Ultrix"*)		ARCH=vax;;
*"RISC iX"*)		ARCH=arm;;
*"Umax 4.2"*)		ARCH=encore;;
*"Alliant Concentrix"*)	ARCH=alliant;;
*"FPS Model 500"*)	ARCH=fps500;;
*"HCX/UX"*)		ARCH=harris;;
*"UNIOS-B"*)		ARCH=luna;;
*"LUNA-88K Mach 2.5"*)	ARCH=luna88k;;
*"LUNA-II Mach 2.5"*)	ARCH=luna2;;
*)			ARCH=unknown;
			if [ -d /usr/include/caif ]; then
				ARCH=ibm032
			elif [ -f /bin/pyr ]; then
				if /bin/pyr; then
					ARCH=pyr
				fi
			elif [ -d /NextApps ]; then
				ARCH=next
			elif [ -f /etc/comply ]; then
				# Tex 4300 is essentially a sun 3.
				ARCH=sun3
			fi
			;;
esac

echo "#	... architecture appears to be \"${ARCH}\"" >&2
echo $ARCH

case "$ARCH" in
unknown) exit 1
esac

exit 0
