/* 
 * WorldWide File System
 * Copyright (c) 1992,1993 Youki Kadobayashi
 * Copyright (c) 1992,1993 Osaka University
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that the following conditions
 * are met:
 * 1. Both the copyright notice and this permission notice appear in
 *    all copies of the software, derivative works or modified versions,
 *    and any portions thereof, and that both notices appear in
 *    supporting documentation.
 * 2. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the Osaka University
 *      and its contributors.
 * 3. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE DEVELOPER ``AS IS'' AND OSAKA
 * UNIVERSITY DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
 * WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Osaka University requests users of this software to return to
 *
 *  Youki Kadobayashi
 *  Department of Information and Computer Sciences
 *  Osaka University, Toyonaka 560, Osaka, Japan
 *
 * any improvements or extensions that they make and grant Osaka
 * University the rights to redistribute these changes.
 */
/*
 * We need "amd" compatibility header here,
 * since I have incorporated NFS portability code of "amd" 5.3 beta 1.
 */

#include "config.h"

#include <sys/param.h>		/* for Ultrix */
#include <sys/socket.h>
#include <rpc/rpc.h>
#include <netdb.h>		/* for hostent */
#include "nfs_prot.h"
#ifdef MNTENT_HDR
#include MNTENT_HDR
#endif /* MNTENT_HDR */
#include <assert.h>

#ifdef DEBUG_MEM
#include <malloc.h>
#endif /* DEBUG_MEM */

#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN 64
#endif /* MAXHOSTNAMELEN */

#ifndef MNTTYPE_WWFS
#define MNTTYPE_WWFS "nfs"
/*
 * Different mount type string, (e.g., "wwfs") requires
 * lots of admininistrative overhead and deep understanding
 * of the internal workings of the whole system.
 */
#endif /* MNTTYPE_WWFS */

#ifndef FALSE
#define FALSE 0
#define TRUE 1
#endif /* FALSE */
#define	ALLOC(ty)	((struct ty *) malloc(sizeof(struct ty)))

/*
 * List of mount table entries
 */
typedef struct mntlist mntlist;
struct mntlist {
	struct mntlist *mnext;
	struct mntent *mnt;
};

/*
 * mostly for amd compatibility
 */
extern char *mtab;		/* Mount table */
extern time_t clock_valid;	/* Clock needs recalculating */
extern int mypid;		/* Current process id */
